// KOTH

void main(void)
{

  // Text
   rmSetStatusText("",0.01);

// Define triggers

for(i=1; <cNumberPlayers)
{
   rmCreateTrigger("StartCountdown"+i);
   rmCreateTrigger("CountdownWarning"+i);
   rmCreateTrigger("CriticalCountdownWarning"+i);
   rmCreateTrigger("StopCountdown"+i);
   rmCreateTrigger("Victory"+i);
}

  

// Start countdown when Player has Vault
for(i=1; <cNumberPlayers)
{
   rmSwitchToTrigger(rmTriggerID("StartCountdown"+i));
   rmSetTriggerActive(true);

   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", i);
   rmSetTriggerConditionParam("ProtoUnit", "Plenty Vault KOTH");
   rmSetTriggerConditionParam("Op", ">");
   rmSetTriggerConditionParamInt("Count", 0);

   rmAddTriggerEffect("Send Chat");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   //rmSetTriggerEffectParam("Message", rmGetPlayerName(i)+" has captured the Plenty Vault! Countdown begins!");
   rmSetTriggerEffectParam("Message", "{PlayerNameString("+i+",22593)}");

   rmAddTriggerEffect("Sound Filename");
   rmSetTriggerEffectParam("Sound", "Fanfare.wav");

   rmAddTriggerEffect("Counter:Add Timer");
   rmSetTriggerEffectParam("Name", "victoryCounter"+i);
   rmSetTriggerEffectParamInt("Start",480);
   rmSetTriggerEffectParamInt("Stop",120);
   //rmSetTriggerEffectParam("Msg", "Time until "+rmGetPlayerName(i)+" is King of the Mountain");
   //rmSetTriggerEffectParam("Msg", "<color=" +  "\\\"   +  "\""  +"{playerColor(i)}"+"\\"+"\""+">{PlayerNameString(i,22594)}");
   rmSetTriggerEffectParam("Msg", "{PlayerIDNameString(" + i + ",22594)}");
   rmSetTriggerEffectParamInt("Event", rmTriggerID("CountdownWarning"+i));

   rmAddTriggerEffect("Fire Event");
   rmSetTriggerEffectParamInt("EventID", rmTriggerID("StopCountdown"+i));
}

// Warn players when Countdown = 2 minutes
for(i=1; <cNumberPlayers)
{
   rmSwitchToTrigger(rmTriggerID("CountdownWarning"+i));
   rmSetTriggerActive(false);

   rmAddTriggerEffect("Send Chat");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   //rmSetTriggerEffectParam("Message", rmGetPlayerName(i)+" will win the game in 2 minutes, if the Plenty Vault is not claimed.");
   rmSetTriggerEffectParam("Message", "{PlayerNameString("+i+",22595)}");

   rmAddTriggerEffect("Sound Filename");
   rmSetTriggerEffectParam("Sound", "Fanfare.wav");

   rmAddTriggerEffect("Counter:Add Timer");
   rmSetTriggerEffectParam("Name", "victoryCounter2"+i);
   rmSetTriggerEffectParamInt("Start",120);
   rmSetTriggerEffectParamInt("Stop",30);
   //rmSetTriggerEffectParam("Msg", "Time until "+rmGetPlayerName(i)+" is King of the Mountain");
   rmSetTriggerEffectParam("Msg", "{PlayerIDNameString(" + i + ",22594)}");
   rmSetTriggerEffectParamInt("Event", rmTriggerID("CriticalCountdownWarning"+i));
}

// Warn players when Countdown = 30 seconds
for(i=1; <cNumberPlayers)
{
   rmSwitchToTrigger(rmTriggerID("CriticalCountdownWarning"+i));
   rmSetTriggerActive(false);

   rmAddTriggerEffect("Send Chat");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   //rmSetTriggerEffectParam("Message", rmGetPlayerName(i)+" will win the game in 30 seconds, if the Plenty Vault is not claimed.");
   rmSetTriggerEffectParam("Message", "{PlayerNameString("+i+",22596)}");

   rmAddTriggerEffect("Sound Filename");
   rmSetTriggerEffectParam("Sound", "Fanfare.wav");

   rmAddTriggerEffect("Counter:Add Timer");
   rmSetTriggerEffectParam("Name", "victoryCounter3"+i);
   rmSetTriggerEffectParamInt("Start",30);
   rmSetTriggerEffectParamInt("Stop",0);
   //rmSetTriggerEffectParam("Msg", "Time until "+rmGetPlayerName(i)+" is King of the Mountain");
   rmSetTriggerEffectParam("Msg", "{PlayerIDNameString(" + i + ",22594)}");
   rmSetTriggerEffectParamInt("Event", rmTriggerID("Victory"+i));
}

// Stop countdown when Player loses Vault
for(i=1; <cNumberPlayers)
{
   rmSwitchToTrigger(rmTriggerID("StopCountdown"+i));
   rmSetTriggerActive(false);

   rmAddTriggerCondition("Player Unit Count");
   rmSetTriggerConditionParamInt("PlayerID", i);
   rmSetTriggerConditionParam("ProtoUnit", "Plenty Vault KOTH");
   rmSetTriggerConditionParam("Op", "<");
   rmSetTriggerConditionParamInt("Count", 1);

   rmAddTriggerEffect("Counter Stop");
   rmSetTriggerEffectParam("Name", "victoryCounter"+i);

   rmAddTriggerEffect("Counter Stop");
   rmSetTriggerEffectParam("Name", "victoryCounter2"+i);

   rmAddTriggerEffect("Counter Stop");
   rmSetTriggerEffectParam("Name", "victoryCounter3"+i);

   rmAddTriggerEffect("Send Chat");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   //rmSetTriggerEffectParam("Message", rmGetPlayerName(i)+" has lost control of the Plenty Vault!");
   rmSetTriggerEffectParam("Message", "{PlayerNameString("+i+",22597)}");

   rmAddTriggerEffect("Fire Event");
   rmSetTriggerEffectParamInt("EventID", rmTriggerID("StartCountdown"+i));
}

// Declare Victory when countdown done
for(i=1; <cNumberPlayers)
{
   rmSwitchToTrigger(rmTriggerID("Victory"+i));
   rmSetTriggerActive(false);

   rmAddTriggerEffect("Send Chat");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   //rmSetTriggerEffectParam("Message", rmGetPlayerName(i)+" is the King of the Mountain and wins the game! ");
   rmSetTriggerEffectParam("Message", "{PlayerNameString("+i+",22598)}");

   rmAddTriggerEffect("Sound Filename");
   rmSetTriggerEffectParam("Sound", "Fanfare.wav");

   rmAddTriggerEffect("Set Player Won");
   rmSetTriggerEffectParamInt("Player", i);
}

// Enable resouces for Plenty Vault
   rmCreateTrigger("Enable Vault");
   rmSetTriggerActive(true);   

   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1",30);
   
for(i=1; <cNumberPlayers)
{
   rmAddTriggerEffect("Set Tech Status");
   rmSetTriggerEffectParamInt("PlayerID", i);
   rmSetTriggerEffectParam("TechID", "378");
   rmSetTriggerEffectParam("Status", "4");
}

// ----------------------------------------------DONE WITH TRIGGERS------------------------------

// Main entry point for random map script


   // Set size.

   int playerTiles=9500;
   if(cMapSize == 1)
   {
      playerTiles = 12750;
      rmEchoInfo("Large map");
   }
   int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles/0.9);
   rmEchoInfo("Map size="+size+"m x "+size+"m");
   rmSetMapSize(size, size);

   /* determine which terrain the map uses */
   int skin=rmRandInt(0,2);

   // Set up default water.
   rmSetSeaLevel(0.0);

   // Init map
   rmSetSeaType("red sea");

   if(skin == 0) 
      rmTerrainInitialize("CliffGreekA", 5);
   if(skin == 1)
      rmTerrainInitialize("CliffEgyptianA", 5);
   if(skin==2)
      rmTerrainInitialize("CliffNorseA", 5);
      
   rmSetGaiaCiv(cCivZeus);
 

   // Define some classes.
   int classPlayer=rmDefineClass("player");
   int classPlayerCore=rmDefineClass("player core");
   rmDefineClass("corner");
   int classPatch=rmDefineClass("patch");
   rmDefineClass("center");
   rmDefineClass("pass");
   rmDefineClass("starting settlement");
   int avoidIce = 0;

   // -------------Define constraints
   
   // Create a edge of map constraint.
   int edgeConstraint=rmCreateBoxConstraint("edge of map", rmXTilesToFraction(4), rmZTilesToFraction(4), 1.0-rmXTilesToFraction(4), 1.0-rmZTilesToFraction(4));
   int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 5.0); 
   int passConstraint=rmCreateClassDistanceConstraint("forests away from pass", rmClassID("pass"), 10.0);

   int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 45.0);
   int patchConstraint=rmCreateClassDistanceConstraint("avoid patch", classPatch, 10.0);

   // Center constraint.
   int centerConstraint=rmCreateClassDistanceConstraint("stay away from center", rmClassID("center"), 15.0);
   int patchCenterConstraint=rmCreateClassDistanceConstraint("patch don't mess up center", rmClassID("center"), 30.0);


   // corner constraint.
   int cornerConstraint=rmCreateClassDistanceConstraint("stay away from corner", rmClassID("corner"), 15.0);
   int cornerOverlapConstraint=rmCreateClassDistanceConstraint("don't overlap corner", rmClassID("corner"), 2.0);

   // Settlement constraints
   int shortAvoidSettlement=rmCreateTypeDistanceConstraint("objects avoid TC by short distance", "AbstractSettlement", 20.0);
   int farAvoidSettlement=rmCreateTypeDistanceConstraint("TCs avoid TCs by long distance", "AbstractSettlement", 40.0);
   int farStartingSettleConstraint=rmCreateClassDistanceConstraint("objects avoid player TCs", rmClassID("starting settlement"), 50.0);
       
   // Tower constraint.
   int avoidTower=rmCreateTypeDistanceConstraint("towers avoid towers", "tower", 25.0);
   int avoidTower2=rmCreateTypeDistanceConstraint("objects avoid towers", "tower", 22.0);

   // Gold
   int avoidGold=rmCreateTypeDistanceConstraint("avoid gold", "gold", 30.0);
   int shortAvoidGold=rmCreateTypeDistanceConstraint("short avoid gold", "gold", 10.0);

   // Food
   int avoidHerdable=rmCreateTypeDistanceConstraint("avoid herdable", "herdable", 30.0);
   int avoidPredator=rmCreateTypeDistanceConstraint("avoid predator", "animalPredator", 20.0);
   int avoidFood=rmCreateTypeDistanceConstraint("avoid other food sources", "food", 6.0);


   // Avoid impassable land
   int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "land", false, 4.0);
   int avoidBuildings=rmCreateTypeDistanceConstraint("avoid buildings", "Building", 20.0);
   int shortAvoidBuildings=rmCreateTypeDistanceConstraint("short avoid buildings", "Building", 10.0);
  
   // -------------Define objects
   // Close Objects

   int startingSettlementID=rmCreateObjectDef("starting settlement");
   rmAddObjectDefItem(startingSettlementID, "Settlement Level 1", 1, 0.0);
   rmAddObjectDefToClass(startingSettlementID, rmClassID("starting settlement"));
   rmSetObjectDefMinDistance(startingSettlementID, 0.0);
   rmSetObjectDefMaxDistance(startingSettlementID, 0.0);

   // towers avoid other towers
   int startingTowerID=rmCreateObjectDef("Starting tower");
   rmAddObjectDefItem(startingTowerID, "tower", 1, 0.0);
   rmSetObjectDefMinDistance(startingTowerID, 22.0);
   rmSetObjectDefMaxDistance(startingTowerID, 28.0);
   rmAddObjectDefConstraint(startingTowerID, avoidTower);
   rmAddObjectDefConstraint(startingTowerID, avoidImpassableLand);
   if(avoidIce==1)
      rmAddObjectDefConstraint(startingTowerID, centerConstraint);
   
   // gold avoids gold
   int startingGoldID=rmCreateObjectDef("Starting gold");
   rmAddObjectDefItem(startingGoldID, "Gold mine small", 1, 0.0);
   rmSetObjectDefMinDistance(startingGoldID, 20.0);
   rmSetObjectDefMaxDistance(startingGoldID, 25.0);
   rmAddObjectDefConstraint(startingGoldID, avoidGold);
   rmAddObjectDefConstraint(startingGoldID, avoidImpassableLand);
   if(avoidIce==1)
      rmAddObjectDefConstraint(startingGoldID, centerConstraint);


   // pigs
   float pigNumber=rmRandFloat(2, 4);
   int herd=rmRandInt(0,2);
   int closePigsID=rmCreateObjectDef("close pigs");
   if(herd==0)
   rmAddObjectDefItem(closePigsID, "pig", pigNumber, 2.0);
   if(herd==1)
   rmAddObjectDefItem(closePigsID, "cow", pigNumber, 2.0);
   if(herd==2)
   rmAddObjectDefItem(closePigsID, "goat", pigNumber, 2.0);
   rmSetObjectDefMinDistance(closePigsID, 25.0);
   rmSetObjectDefMaxDistance(closePigsID, 30.0);
   rmAddObjectDefConstraint(closePigsID, avoidImpassableLand);
   rmAddObjectDefConstraint(closePigsID, avoidFood);
   
   int closeChickensID=rmCreateObjectDef("close Chickens");
   int chick=rmRandInt(0,1);
   if(chick==0)
   rmAddObjectDefItem(closeChickensID, "chicken", rmRandInt(6,9), 5.0);
   if(chick==1)
   rmAddObjectDefItem(closeChickensID, "berry bush", rmRandInt(6,9), 5.0);
   rmSetObjectDefMinDistance(closeChickensID, 20.0);
   rmSetObjectDefMaxDistance(closeChickensID, 25.0);
   rmAddObjectDefConstraint(closeChickensID, avoidImpassableLand);
   rmAddObjectDefConstraint(closeChickensID, avoidFood);
   if(avoidIce==1)
      rmAddObjectDefConstraint(closeChickensID, centerConstraint);

   int closeBoarID=rmCreateObjectDef("close Boar");
   int boar=rmRandInt(0,2);
   if(skin == 1)
   {
      if(boar==0)
      rmAddObjectDefItem(closeBoarID, "rhinocerous", 2, 4.0);
      if(boar==1)
      rmAddObjectDefItem(closeBoarID, "hippo", 2, 4.0);
      if(boar==2)
      rmAddObjectDefItem(closeBoarID, "elephant", 2, 4.0);
   }
   else
      rmAddObjectDefItem(closeBoarID, "boar", 3, 4.0);
   rmSetObjectDefMinDistance(closeBoarID, 40.0);
   rmSetObjectDefMaxDistance(closeBoarID, 60.0);
   rmAddObjectDefConstraint(closeBoarID, avoidImpassableLand);
   if(avoidIce==1)
      rmAddObjectDefConstraint(closeBoarID, centerConstraint);

   int stragglerTreeID=rmCreateObjectDef("straggler tree");
   if(skin == 0)
      rmAddObjectDefItem(stragglerTreeID, "oak tree", 1, 0.0);
   if(skin == 1)
      rmAddObjectDefItem(stragglerTreeID, "palm", 1, 0.0);
   if(skin == 2)
      rmAddObjectDefItem(stragglerTreeID, "pine snow", 1, 0.0);
   rmSetObjectDefMinDistance(stragglerTreeID, 12.0);
   rmSetObjectDefMaxDistance(stragglerTreeID, 15.0);
   rmAddObjectDefConstraint(stragglerTreeID, centerConstraint);


   // Medium Objects

   // gold avoids gold and Settlements
   int mediumGoldID=rmCreateObjectDef("medium gold");
   rmAddObjectDefItem(mediumGoldID, "Gold mine", 1, 0.0);
   rmSetObjectDefMinDistance(mediumGoldID, 40.0);
   rmSetObjectDefMaxDistance(mediumGoldID, 60.0);
   rmAddObjectDefConstraint(mediumGoldID, avoidGold);
   rmAddObjectDefConstraint(mediumGoldID, edgeConstraint);
   rmAddObjectDefConstraint(mediumGoldID, centerConstraint);
   rmAddObjectDefConstraint(mediumGoldID, shortAvoidSettlement);
   rmAddObjectDefConstraint(mediumGoldID, farStartingSettleConstraint);
   rmAddObjectDefConstraint(mediumGoldID, avoidImpassableLand);
   if(avoidIce==1)
      rmAddObjectDefConstraint(mediumGoldID, centerConstraint);

   int mediumPigsID=rmCreateObjectDef("medium pigs");
   herd=rmRandInt(0,2);
   if(herd==0)
   rmAddObjectDefItem(mediumPigsID, "pig", rmRandInt(1,3), 2.0);
   if(herd==1)
   rmAddObjectDefItem(mediumPigsID, "cow", rmRandInt(1,3), 2.0);
   if(herd==2)
   rmAddObjectDefItem(mediumPigsID, "goat", rmRandInt(1,3), 2.0);
   rmSetObjectDefMinDistance(mediumPigsID, 60.0);
   rmSetObjectDefMaxDistance(mediumPigsID, 80.0);
   rmAddObjectDefConstraint(mediumPigsID, avoidImpassableLand);
   rmAddObjectDefConstraint(mediumPigsID, avoidHerdable);
   rmAddObjectDefConstraint(mediumPigsID, farStartingSettleConstraint);
   rmAddObjectDefConstraint(mediumPigsID, centerConstraint);

   
   // Far Objects

   // gold avoids gold, Settlements and TCs
   int farGoldID=rmCreateObjectDef("far gold");
   rmAddObjectDefItem(farGoldID, "Gold mine", 1, 0.0);
   rmSetObjectDefMinDistance(farGoldID, 70.0);
   rmSetObjectDefMaxDistance(farGoldID, 160.0);
   rmAddObjectDefConstraint(farGoldID, avoidGold);
   rmAddObjectDefConstraint(farGoldID, avoidImpassableLand);
   rmAddObjectDefConstraint(farGoldID, shortAvoidSettlement);
   rmAddObjectDefConstraint(farGoldID, centerConstraint);
   rmAddObjectDefConstraint(farGoldID, farStartingSettleConstraint);

   // pigs avoid TCs and other herds, since this map places a lot of pigs
   int farPigsID=rmCreateObjectDef("far pigs");
   herd=rmRandInt(0,2);
   if(herd==0)
   rmAddObjectDefItem(farPigsID, "pig", rmRandInt(2,3), 2.0);
   if(herd==1)
   rmAddObjectDefItem(farPigsID, "cow", rmRandInt(2,3), 2.0);
   if(herd==2)
   rmAddObjectDefItem(farPigsID, "goat", rmRandInt(2,3), 2.0);
   rmSetObjectDefMinDistance(farPigsID, 60.0);
   rmSetObjectDefMaxDistance(farPigsID, 150.0);
   rmAddObjectDefConstraint(farPigsID, avoidImpassableLand);
   rmAddObjectDefConstraint(farPigsID, avoidHerdable);
   rmAddObjectDefConstraint(farPigsID, centerConstraint);
   rmAddObjectDefConstraint(farPigsID, farStartingSettleConstraint);
   
   // pick lions or bears as predators
   // avoid TCs
   int farPredatorID=rmCreateObjectDef("far predator");
   int pred=rmRandInt(0,1);
   if(skin == 0)
   {
      if(pred==0)
      rmAddObjectDefItem(farPredatorID, "wolf", 4, 4.0);
      if(pred==1)
      rmAddObjectDefItem(farPredatorID, "bear", 2, 4.0);
   }
   if(skin == 1)
   {
      if(pred==0)
      rmAddObjectDefItem(farPredatorID, "lion", 2, 4.0);
      if(pred==1)
      rmAddObjectDefItem(farPredatorID, "crocodile", 2, 4.0);
   }
   if(skin == 2)
   {
      if(pred==0)
      rmAddObjectDefItem(farPredatorID, "wolf", 4, 4.0);
      if(pred==1)
      rmAddObjectDefItem(farPredatorID, "polar bear", 2, 4.0);
   }
   rmSetObjectDefMinDistance(farPredatorID, 50.0);
   rmSetObjectDefMaxDistance(farPredatorID, 100.0);
   rmAddObjectDefConstraint(farPredatorID, avoidPredator);
   rmAddObjectDefConstraint(farPredatorID, farStartingSettleConstraint);
   rmAddObjectDefConstraint(farPredatorID, avoidImpassableLand);
   
   // Berries avoid TCs  
   int farBerriesID=rmCreateObjectDef("far berries");
   rmAddObjectDefItem(farBerriesID, "berry bush", 10, 4.0);
   rmSetObjectDefMinDistance(farBerriesID, 0.0);
   rmSetObjectDefMaxDistance(farBerriesID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(farBerriesID, avoidImpassableLand);
   rmAddObjectDefConstraint(farBerriesID, farStartingSettleConstraint);
   rmAddObjectDefConstraint(farBerriesID, centerConstraint);
   
   // This map will either use boar or deer as the extra huntable food.
   int classBonusHuntable=rmDefineClass("bonus huntable");
   int avoidBonusHuntable=rmCreateClassDistanceConstraint("avoid bonus huntable", classBonusHuntable, 40.0);
   int avoidHuntable=rmCreateTypeDistanceConstraint("avoid huntable", "huntable", 20.0);

   // hunted avoids hunted and TCs
   int bonusHuntableID=rmCreateObjectDef("bonus huntable");
   int hunt=rmRandInt(0, 1);
   int numhunt=rmRandInt(6,10);
   if(skin == 0)
      rmAddObjectDefItem(bonusHuntableID, "deer", numhunt, 10.0);
   if(skin == 1)
   {
      if(hunt==0)
      rmAddObjectDefItem(bonusHuntableID, "zebra", numhunt, 10.0);
      if(hunt==1)
      rmAddObjectDefItem(bonusHuntableID, "giraffe", numhunt, 10.0);
   }
   if(skin == 2)
   {
      if(hunt==0)
      rmAddObjectDefItem(bonusHuntableID, "elk", numhunt, 10.0);
      if(hunt==1)
      rmAddObjectDefItem(bonusHuntableID, "caribou", numhunt, 10.0);
   }
   rmSetObjectDefMinDistance(bonusHuntableID, 0.0);
   rmSetObjectDefMaxDistance(bonusHuntableID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(bonusHuntableID, avoidBonusHuntable);
   rmAddObjectDefConstraint(bonusHuntableID, avoidHuntable);
   rmAddObjectDefToClass(bonusHuntableID, classBonusHuntable);
   rmAddObjectDefConstraint(bonusHuntableID, farStartingSettleConstraint);
   rmAddObjectDefConstraint(bonusHuntableID, avoidImpassableLand);
   rmAddObjectDefConstraint(bonusHuntableID, shortAvoidBuildings);
   rmAddObjectDefConstraint(bonusHuntableID, centerConstraint);

   int randomTreeID=rmCreateObjectDef("random tree");
   if(skin == 0)
      rmAddObjectDefItem(randomTreeID, "oak tree", 1, 0.0);
   if(skin == 1)
      rmAddObjectDefItem(randomTreeID, "palm", 1, 0.0);
   if(skin == 2)
      rmAddObjectDefItem(randomTreeID, "pine snow", 1, 0.0);
   rmSetObjectDefMinDistance(randomTreeID, 0.0);
   rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(randomTreeID, rmCreateTypeDistanceConstraint("random tree", "all", 4.0));
   rmAddObjectDefConstraint(randomTreeID, shortAvoidSettlement);
   rmAddObjectDefConstraint(randomTreeID, avoidImpassableLand);
   rmAddObjectDefConstraint(randomTreeID, centerConstraint);

    // Birds
   int farhawkID=rmCreateObjectDef("far hawks");
   if(skin==1)
   rmAddObjectDefItem(farhawkID, "vulture", 1, 0.0);
   else
   rmAddObjectDefItem(farhawkID, "hawk", 1, 0.0);
   rmSetObjectDefMinDistance(farhawkID, 0.0);
   rmSetObjectDefMaxDistance(farhawkID, rmXFractionToMeters(0.5));

   // Relics avoid TCs
   int relicID=rmCreateObjectDef("relic");
   rmAddObjectDefItem(relicID, "relic", 1, 0.0);
   rmSetObjectDefMinDistance(relicID, 60.0);
   rmSetObjectDefMaxDistance(relicID, 150.0);
   rmAddObjectDefConstraint(relicID, edgeConstraint);
   rmAddObjectDefConstraint(relicID, rmCreateTypeDistanceConstraint("relic vs relic", "relic", 70.0));
   rmAddObjectDefConstraint(relicID, farStartingSettleConstraint);
   rmAddObjectDefConstraint(relicID, avoidImpassableLand);
   rmAddObjectDefConstraint(relicID, centerConstraint);

   int fort=rmCreateObjectDef("fort");
   if(skin==0)
   rmAddObjectDefItem(fort, "fortress", 1, 0.0);
   if(skin==1)
   rmAddObjectDefItem(fort, "migdol stronghold", 1, 0.0);
   if(skin==2)
   rmAddObjectDefItem(fort, "hill fort", 1, 0.0);
   rmAddObjectDefConstraint(fort, avoidAll);
   rmSetObjectDefMinDistance(fort, 10.0);
   rmSetObjectDefMaxDistance(fort, 50.0);
   rmAddObjectDefConstraint(fort, avoidImpassableLand);

   int infantry=rmCreateObjectDef("infantry");
   if(skin==0)
   rmAddObjectDefItem(infantry, "toxotes", 8, 10.0);
   if(skin==1)
   rmAddObjectDefItem(infantry, "slinger", 9, 10.0);
   if(skin==2)
   rmAddObjectDefItem(infantry, "throwing axeman", 9, 10.0);
   rmAddObjectDefConstraint(infantry, avoidAll);
   rmSetObjectDefMinDistance(infantry, 10.0);
   rmSetObjectDefMaxDistance(infantry, 40.0);
   rmAddObjectDefConstraint(infantry, avoidImpassableLand);

   int myth=rmCreateObjectDef("myth");
   if(skin==0)
   rmAddObjectDefItem(myth, "medusa", 3, 5.0);
   if(skin==1)
   rmAddObjectDefItem(myth, "mummy", 3, 5.0);
   if(skin==2)
   rmAddObjectDefItem(myth, "fire giant", 3, 5.0);
   rmAddObjectDefConstraint(myth, avoidAll);
   rmSetObjectDefMinDistance(myth, 5.0);
   rmSetObjectDefMaxDistance(myth, 40.0);
   rmAddObjectDefConstraint(myth, avoidImpassableLand);

   int plentygold=rmCreateObjectDef("plentygold");
   rmAddObjectDefItem(plentygold, "Gold mine", 1, 5.0);
   rmAddObjectDefConstraint(plentygold, avoidAll);
   rmSetObjectDefMinDistance(plentygold, 5.0);
   rmSetObjectDefMaxDistance(plentygold, 30.0);
   rmAddObjectDefConstraint(plentygold, avoidImpassableLand);

   int plentyrelic=rmCreateObjectDef("plentyrelic");
   rmAddObjectDefItem(plentyrelic, "relic", 1, 20.0);
   rmAddObjectDefConstraint(plentyrelic, avoidAll);
   rmSetObjectDefMinDistance(plentyrelic, 5.0);
   rmSetObjectDefMaxDistance(plentyrelic, 50.0);
   rmAddObjectDefConstraint(plentyrelic, avoidImpassableLand);

   int ballista=rmCreateObjectDef("ballista");
   rmAddObjectDefItem(ballista, "ballista", 7, 20.0);
   rmAddObjectDefConstraint(ballista, avoidAll);
   rmSetObjectDefMinDistance(ballista, 5.0);
   rmSetObjectDefMaxDistance(ballista, 40.0);
   rmAddObjectDefConstraint(ballista, avoidImpassableLand);

   // ------------------------------------------------------------------------Done defining objects

   // Cheesy "circular" placement of players.
   rmSetTeamSpacingModifier(0.75);
   rmPlacePlayersSquare(0.4, 0.43, rmDegreesToRadians(5.0));


   // Determine center
   int centerID=rmCreateArea("center");
   rmSetAreaLocation(centerID, 0.5, 0.5);
   rmSetAreaBaseHeight(centerID, 12.0);
   rmSetAreaHeightBlend(centerID, 20.0);
   if(skin == 0)
   {
      rmSetAreaTerrainType(centerID, "CliffGreekA");
      rmSetAreaSize(centerID, 0.10, 0.10);
   }
   if(skin == 1)
   {
      rmSetAreaWaterType(centerID, "CliffEgyptianA");
      rmSetAreaSize(centerID, 0.10, 0.10);

   }
   if(skin == 2)
   {
      rmSetAreaTerrainType(centerID, "CliffNorseA");
      rmSetAreaSize(centerID, 0.10, 0.10);
   }
   rmAddAreaToClass(centerID, rmClassID("center"));
   rmSetAreaMinBlobs(centerID, 8);
   rmSetAreaMaxBlobs(centerID, 10);
   rmSetAreaMinBlobDistance(centerID, 10);
   rmSetAreaMaxBlobDistance(centerID, 20);
   rmSetAreaSmoothDistance(centerID, 50);
   rmSetAreaCoherence(centerID, 0.25);
   rmBuildArea(centerID); 

    // Ruins
   int ruinID=0;
  /* int stayInRuins=rmCreateEdgeDistanceConstraint("stay in ruins", ruinID, 4.0); */

   ruinID=rmCreateArea("ruins");
   rmSetAreaSize(ruinID, rmAreaTilesToFraction(1500), rmAreaTilesToFraction(1500));
   rmSetAreaLocation(ruinID, 0.5, 0.5);
   if(skin == 0)
   rmSetAreaTerrainType(ruinID, "GreekRoadA");
   if(skin == 1)
   rmSetAreaTerrainType(ruinID, "EgyptianRoadA");
   if(skin ==2)
   rmSetAreaTerrainType(ruinID, "NorseRoadA");
   rmSetAreaMinBlobs(ruinID, 1);
   rmSetAreaMaxBlobs(ruinID, 1);
   rmSetAreaCoherence(ruinID, 0.8);
   rmSetAreaSmoothDistance(ruinID, 10);
   rmBuildArea(ruinID);
       
  // Set up player areas.
   float playerFraction=rmAreaTilesToFraction(3000);
   for(i=1; <cNumberPlayers)
   {
      // Create the area.
      int id=rmCreateArea("Player"+i);

      // Assign to the player.
      rmSetPlayerArea(i, id);

      // Set the size.
      rmSetAreaSize(id, 2.9*playerFraction, 3.0*playerFraction);

      rmAddAreaToClass(id, classPlayer);

      rmSetAreaMinBlobs(id, 4);
      rmSetAreaMaxBlobs(id, 5);
      rmSetAreaWarnFailure(id, false);
      rmSetAreaMinBlobDistance(id, 30.0);
      rmSetAreaMaxBlobDistance(id, 50.0);
      rmSetAreaSmoothDistance(id, 20);
      rmSetAreaCoherence(id, 0.20);
      rmSetAreaBaseHeight(id, 0.0); 
      rmSetAreaHeightBlend(id, 2);
      rmAddAreaConstraint(id, playerConstraint);
      rmAddAreaConstraint(id, centerConstraint);
      rmSetAreaLocPlayer(id, i);

      int pass=rmCreateArea("Passage"+i);
      rmSetAreaSize(pass, 0.025, 0.025);
      rmSetAreaLocPlayer(pass, i);
      rmSetAreaCoherence(pass, 2.0);
      rmSetAreaHeightBlend(pass, 2);
      rmAddAreaToClass(pass, rmClassID("pass"));
      rmAddAreaInfluenceSegment(pass, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i), 0.5, 0.5);
      if(skin==0)
      rmSetAreaTerrainType(pass, "GreekRoadA");
      if(skin==1)
      rmSetAreaTerrainType(pass, "EgyptianRoadA");
      if(skin==2)
      rmSetAreaTerrainType(pass, "NorseRoadA");
      rmBuildArea(pass);

      if(skin == 0)
      {
         rmSetAreaTerrainType(id, "GrassDirt50");
         rmAddAreaTerrainLayer(id, "GrassDirt25", 5, 8);
         rmAddAreaTerrainLayer(id, "GrassA", 0, 3);
      }
      if(skin == 1)
      {
         rmSetAreaTerrainType(id, "GrassDirt50");
         rmAddAreaTerrainLayer(id, "GrassDirt75", 5, 8);
         rmAddAreaTerrainLayer(id, "SandA", 0, 3);
      }
      if(skin == 2)
      {
         rmSetAreaTerrainType(id, "SnowGrass25");
         rmAddAreaTerrainLayer(id, "SnowA", 5, 8);
         rmAddAreaTerrainLayer(id, "SnowB", 0, 3);
      }
   }

   // Build the areas.
   rmBuildAllAreas();

   // Text
   rmSetStatusText("",0.20);

   int failCount=0;
   for(i=1; <cNumberPlayers*4)
   {
      // Beautification sub area.
      int id2=rmCreateArea("large patch "+i);
      rmSetAreaSize(id2, rmAreaTilesToFraction(200), rmAreaTilesToFraction(400));
      if(skin == 0)
         rmSetAreaTerrainType(id2, "GrassDirt50");
      else if(skin == 1)
      {
         rmSetAreaTerrainType(id2, "GrassDirt50");
         rmAddAreaTerrainLayer(id2, "GrassDirt75", 0, 3);
      }
      else
      {
         rmSetAreaTerrainType(id2, "SnowGrass50");
         rmAddAreaTerrainLayer(id2, "SnowGrass25", 0, 3);
      }
      rmAddAreaToClass(id2, classPatch);
      rmAddAreaConstraint(id2, patchConstraint);
      rmAddAreaConstraint(id2, patchCenterConstraint);
      rmAddAreaConstraint(id2, avoidImpassableLand);
      rmSetAreaMinBlobs(id2, 1);
      rmSetAreaMaxBlobs(id2, 5);
      rmSetAreaWarnFailure(id2, false);
      rmSetAreaMinBlobDistance(id2, 16.0);
      rmSetAreaMaxBlobDistance(id2, 40.0);
      rmSetAreaCoherence(id2, 0.0);
      if(rmBuildArea(id2)==false)
      {
         // Stop trying once we fail 20 times in a row.
         failCount++;
         if(failCount==20)
            break;
      }
      else
         failCount=0;
   }

   failCount=0;
   for(i=1; <cNumberPlayers*4)
   {
      // Beautification sub area.
      int id3=rmCreateArea("small patch "+i);
      rmSetAreaSize(id3, rmAreaTilesToFraction(100), rmAreaTilesToFraction(300));
      if(skin == 0)
         rmSetAreaTerrainType(id3, "GrassDirt25");
      if(skin == 1)
         rmSetAreaTerrainType(id3, "SandD");
      if(skin == 2)
         rmSetAreaTerrainType(id3, "SnowB");
      rmAddAreaToClass(id3, classPatch);
      rmAddAreaConstraint(id3, patchConstraint);
      rmAddAreaConstraint(id3, patchCenterConstraint);
      rmAddAreaConstraint(id3, avoidImpassableLand);
      rmSetAreaMinBlobs(id3, 1);
      rmSetAreaMaxBlobs(id3, 5);
      rmSetAreaWarnFailure(id3, false);
      rmSetAreaMinBlobDistance(id3, 16.0);
      rmSetAreaMaxBlobDistance(id3, 40.0);
      rmSetAreaCoherence(id3, 0.0);

      if(rmBuildArea(id3)==false)
      {
         // Stop trying once we fail 20 times in a row.
         failCount++;
         if(failCount==20)
            break;
      }
      else
         failCount=0;

   }

   // Place starting settlements.
   // Close things....
   // TC
   rmPlaceObjectDefPerPlayer(startingSettlementID, true);

   // Elev.
   int numTries=4*cNumberNonGaiaPlayers;
   failCount=0;
   for(i=0; <numTries)
   {
      int elevID=rmCreateArea("elev"+i);
      rmSetAreaSize(elevID, rmAreaTilesToFraction(15), rmAreaTilesToFraction(80));
      rmSetAreaLocation(elevID, rmRandFloat(0.0, 1.0), rmRandFloat(0.0, 1.0));
      rmSetAreaWarnFailure(elevID, false);
      rmAddAreaConstraint(elevID, avoidBuildings);
      rmAddAreaConstraint(elevID, centerConstraint);
      rmAddAreaConstraint(elevID, avoidImpassableLand);
      rmSetAreaBaseHeight(elevID, rmRandFloat(3.0, 4.0));
      rmSetAreaMinBlobs(elevID, 1);
      rmSetAreaMaxBlobs(elevID, 5);
      rmSetAreaMinBlobDistance(elevID, 16.0);
      rmSetAreaMaxBlobDistance(elevID, 40.0);
      rmSetAreaCoherence(elevID, 0.0);

      if(rmBuildArea(elevID)==false)
      {
         // Stop trying once we fail 20 times in a row.
         failCount++;
         if(failCount==20)
            break;
      }
      else
         failCount=0;
   }

   // Slight Elevation
   numTries=4*cNumberNonGaiaPlayers;
   failCount=0;
   for(i=0; <numTries)
   {
      elevID=rmCreateArea("wrinkle"+i);
      rmSetAreaSize(elevID, rmAreaTilesToFraction(100), rmAreaTilesToFraction(200));
      rmSetAreaLocation(elevID, rmRandFloat(0.0, 1.0), rmRandFloat(0.0, 1.0));
      rmSetAreaWarnFailure(elevID, false);
      rmSetAreaBaseHeight(elevID, rmRandFloat(1.0, 3.0));
      rmSetAreaMinBlobs(elevID, 1);
      rmSetAreaMaxBlobs(elevID, 3);
      rmSetAreaMinBlobDistance(elevID, 16.0);
      rmSetAreaMaxBlobDistance(elevID, 20.0);
      rmSetAreaCoherence(elevID, 0.0);
      rmAddAreaConstraint(elevID, avoidBuildings);
      rmAddAreaConstraint(elevID, centerConstraint);
      rmAddAreaConstraint(elevID, avoidImpassableLand);
      if(rmBuildArea(elevID)==false)
      {
         // Stop trying once we fail 10 times in a row.
         failCount++;
         if(failCount==10)
            break;
      }
      else
         failCount=0;
   } 

   int vaultID=rmCreateObjectDef("Vault");
   rmAddObjectDefItem(vaultID, "plenty vault koth", 1, 0.0);
   rmSetObjectDefMinDistance(vaultID, 0.0);
   rmSetObjectDefMinDistance(vaultID, 0.0);
   rmPlaceObjectDefAtLoc(vaultID, 0, 0.5, 0.5);

   int revealID=rmCreateObjectDef("reveal");
   rmAddObjectDefItem(revealID, "Revealer", 1, 30.0);
   rmSetObjectDefMinDistance(revealID, 5.0);
   rmSetObjectDefMinDistance(revealID, 30.0);
   rmPlaceObjectDefAtLoc(revealID, 0, 0.5, 0.5, 50);

// For Plenty:
   // Fortress
   rmPlaceObjectDefAtLoc(fort, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
   // Archers
   rmPlaceObjectDefAtLoc(infantry, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
   // MUs
   rmPlaceObjectDefAtLoc(myth, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
   // Gold
   rmPlaceObjectDefAtLoc(plentygold, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
   // Relics
   rmPlaceObjectDefAtLoc(plentyrelic, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
   // Ballista
   rmPlaceObjectDefAtLoc(ballista, 0, 0.5, 0.5, cNumberNonGaiaPlayers);

   // Settlements.
   //rmPlaceObjectDefPerPlayer(farSettlementID, true, 2);
   id=rmAddFairLoc("Settlement", false, true,  60, 80, 40, 10);
   rmAddFairLocConstraint(id, centerConstraint);

   id=rmAddFairLoc("Settlement", true, false, 70, 120, 60, 10);
   rmAddFairLocConstraint(id, centerConstraint);

   if(rmPlaceFairLocs())
   {
      id=rmCreateObjectDef("far settlement2");
      rmAddObjectDefItem(id, "Settlement", 1, 0.0);
      for(i=1; <cNumberPlayers)
      {
         for(j=0; <rmGetNumberFairLocs(i))
            rmPlaceObjectDefAtLoc(id, i, rmFairLocXFraction(i, j), rmFairLocZFraction(i, j), 1);
      }
   }

   // Towers.
   rmPlaceObjectDefPerPlayer(startingTowerID, true, 4);

   // Straggler trees.
   rmPlaceObjectDefPerPlayer(stragglerTreeID, false, 3);
   
   // Text
   rmSetStatusText("",0.40);

   // Gold
   rmPlaceObjectDefPerPlayer(startingGoldID, false);

   // Goats
   rmPlaceObjectDefPerPlayer(closePigsID, true, 2);

   //Chickens
   rmPlaceObjectDefPerPlayer(closeChickensID, true);

   // Boar.
   rmPlaceObjectDefPerPlayer(closeBoarID, false, 2);

   // Medium things....
   // Gold
   rmPlaceObjectDefPerPlayer(mediumGoldID, false, 2);

   // Pigs
   rmPlaceObjectDefPerPlayer(mediumPigsID, false, 3);
  
   // Far things.
   
   // Gold.
   rmPlaceObjectDefPerPlayer(farGoldID, false, 4);

   // Relics
   rmPlaceObjectDefPerPlayer(relicID, false);

   // Hawks
   rmPlaceObjectDefPerPlayer(farhawkID, false, 2); 
   
   // Text
   rmSetStatusText("",0.60);

   // Pigs
   for(i=1; <cNumberPlayers)
      rmPlaceObjectDefAtLoc(farPigsID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i), 4);

   // Bonus huntable.
   rmPlaceObjectDefAtLoc(bonusHuntableID, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);

   // Berries.
   rmPlaceObjectDefAtLoc(farBerriesID, 0, 0.5, 0.5, cNumberPlayers);

   // Predators
   rmPlaceObjectDefPerPlayer(farPredatorID, false, 2);

   // Text
   rmSetStatusText("",0.80);

   // Random trees.
   rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);

   // Forest.
   int classForest=rmDefineClass("forest");
   int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
   int forestConstraint=rmCreateClassDistanceConstraint("forest v forest", rmClassID("forest"), 10.0);
   int forestSettleConstraint=rmCreateClassDistanceConstraint("forest settle", rmClassID("starting settlement"), 20.0);
   int forestCount=8*cNumberNonGaiaPlayers;
   failCount=0;
   for(i=0; <forestCount)
   {
      int forestID=rmCreateArea("forest"+i);
      rmSetAreaSize(forestID, rmAreaTilesToFraction(75), rmAreaTilesToFraction(125));
      rmSetAreaWarnFailure(forestID, false);
      if(skin == 0)
         rmSetAreaForestType(forestID, "oak forest");
      if(skin == 1)
         rmSetAreaForestType(forestID, "palm forest");
      if(skin == 2)
         rmSetAreaForestType(forestID, "snow pine forest");
      rmAddAreaConstraint(forestID, forestSettleConstraint);
      rmAddAreaConstraint(forestID, forestObjConstraint);
      rmAddAreaConstraint(forestID, forestConstraint);
      rmAddAreaConstraint(forestID, centerConstraint);
      rmAddAreaConstraint(forestID, avoidImpassableLand);
      rmAddAreaConstraint(forestID, passConstraint);
      rmAddAreaToClass(forestID, classForest);
      
      rmSetAreaMinBlobs(forestID, 1);
      rmSetAreaMaxBlobs(forestID, 5);
      rmSetAreaMinBlobDistance(forestID, 16.0);
      rmSetAreaMaxBlobDistance(forestID, 40.0);
      rmSetAreaCoherence(forestID, 0.0);

      if(rmBuildArea(forestID)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==3)
            break;
      }
      else
         failCount=0;
   }

   // Text
   rmSetStatusText("",0.90);

   int rockID=rmCreateObjectDef("rock and grass");
   int avoidRock0=rmCreateTypeDistanceConstraint("avoid rock 0", "rock limestone sprite", 8.0);
   int avoidRock1=rmCreateTypeDistanceConstraint("avoid rock 1", "rock sandstone sprite", 8.0);
   int avoidRock2=rmCreateTypeDistanceConstraint("avoid rock 2", "rock granite sprite", 8.0);

   if(skin == 0) /* Greek */
      rmAddObjectDefItem(rockID, "rock limestone sprite", 1, 1.0);
   else if(skin == 1) /* E */
      rmAddObjectDefItem(rockID, "rock sandstone sprite", 1, 1.0);
   else
      rmAddObjectDefItem(rockID, "rock granite sprite", 1, 1.0);
   rmAddObjectDefItem(rockID, "grass", 2, 1.0);
   rmSetObjectDefMinDistance(rockID, 0.0);
   rmSetObjectDefMaxDistance(rockID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(rockID, avoidAll);
   rmAddObjectDefConstraint(rockID, avoidImpassableLand);
   rmAddObjectDefConstraint(rockID, avoidRock0);
   rmAddObjectDefConstraint(rockID, avoidRock1);
   rmAddObjectDefConstraint(rockID, avoidRock2);
   if(skin == 2)
      rmAddObjectDefConstraint(rockID, centerConstraint);
   rmPlaceObjectDefAtLoc(rockID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);

   int rockID2=rmCreateObjectDef("rock group");
   if(skin == 0) /* Greek */
      rmAddObjectDefItem(rockID2, "rock limestone sprite", 3, 2.0);
   else if(skin == 1) /* E */
      rmAddObjectDefItem(rockID2, "rock sandstone sprite", 3, 2.0);
   else
      rmAddObjectDefItem(rockID2, "rock granite sprite", 3, 2.0);
   rmSetObjectDefMinDistance(rockID2, 0.0);
   rmSetObjectDefMaxDistance(rockID2, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(rockID2, avoidAll);
   rmAddObjectDefConstraint(rockID2, avoidImpassableLand);
   rmAddObjectDefConstraint(rockID2, avoidRock0);
   rmAddObjectDefConstraint(rockID2, avoidRock1);
   rmAddObjectDefConstraint(rockID2, avoidRock2);
   if(skin == 2)
      rmAddObjectDefConstraint(rockID2, centerConstraint); 
   rmPlaceObjectDefAtLoc(rockID2, 0, 0.5, 0.5, 8*cNumberNonGaiaPlayers);


   // Text
   rmSetStatusText("",1.00);
}  
